#!/bin/csh -f
# Script to grind nice program listings using TeX.
#
# written Feb, 1985 by Van Jacobson, Lawrence Berkeley Laboratory (adapted
# from the 4.2bsd "vgrind" script).
#
# Since TeX output handling is site dependent, you'll have to edit this
# file to get output to your local typesetting device(s).  Our site uses
# Put something appropriate to your site at the "PUT OUTPUT # HANDLING..."
# comment at the end of this script.
#
set b=/usr/local/lib/tgrind/tfontedpr
set tex=/usr/bin/tex
set options=
set texoptions=
set files=
set head=""
set format=""
set quiet="-q"
set tquiet=">! /dev/null"
top:
if ($#argv > 0) then
    switch ($1:q)

    case -d:
	if ($#argv < 2) then
	    echo "tgrind: $1:q option must have argument"
	    goto done
	else
	    set options = ($options $1:q $2)
	    shift
	    shift
	    goto top
	endif

    case -o:
	if ($#argv < 2) then
	    echo "tgrind: $1:q option must have argument"
	    goto done
	else
	    set format="F"
	    if ($2:r == $2) then
	       set outfile = $2.ps
	    else
	       set outfile = $2
	    endif
	    shift
	    shift
	    goto top
	endif

			
    case -f:
	set format="Y"
	shift
	goto top

    case -h:
	if ($#argv < 2) then
	    echo "tgrind: $1:q option must have argument"
	    goto done
	else
	    set head="$2"
	    shift
	    shift
	    goto top
	endif
			
    case -v:
	set quiet = ""
	set tquiet = ""
	shift
	goto top

    case -*:
	set options = "$options $1:q"
	shift
	goto top

    default:
	set files = "$files $1:q"
	shift
	goto top
    endsw
endif

if ("$format" == "Y") then
    if ("$head" != "") then
	$b $options -h "$head" $files
    else
	$b $options $files
    endif
    goto done
endif

if ("$head" != "") then
    $b $options -h "$head" $files >$$.tex
else
    $b $options $files >$$.tex
endif
eval $tex $texoptions $$.tex $tquiet

# PUT OUTPUT HANDLING COMMANDS HERE.

if ("$format" == "F") then
   dvips $quiet -o ${outfile:r}.ps $$
else
   dvips $quiet -f < $$.dvi
endif

rm -f $$.tex $$.log $$.dvi

done:
